%
% CWEB/INCLUDE $VER: CWEB_PC850.W 1.6 (13.01.2019)
%
% SYNOPSIS:
%    Transliteration table for umlauts and special characters
%    according to the IBM PC International Codepage 850.
%    @@include this file in limbo.
%    Note that not all equivalents to the TeX macros are present.
%
% DATE: 28.03.94: Derived from PC850.TEX (V1.0)
%
% AUTHOR:
%    Andreas Scherer <https://ascherer.github.io/>
%
% Please send suggestions (pull requests) and bug reports (issues)
% to https://github.com/ascherer/cwebbin
%
% COPYRIGHT: There is no restriction to the usage of this file.
%
% CHANGES:
%    March 25, 1996: New postal address.  (V1.2)
%    August 13, 1998: New e-mail address.  (V1.3)
%    June 11, 2000: Include matching TeX macros.  (V1.4)
%    July 10, 2017: Complete overhaul.  (V1.5)
%    January 13, 2019: Non-generic names.  (V1.6)

\input cweb_pc850.sty
\noatl

@l 80 C    @l 81 ue   @l 82 e    @l 83 a    @l 84 ae   @l 85 a
@l 86 aa   @l 87 c    @l 88 e    @l 89 ee   @l 8a e    @l 8b ie
@l 8c i    @l 8d i    @l 8e Ae   @l 8f AA
@l 90 E    @l 91 ae   @l 92 AE   @l 93 o    @l 94 oe   @l 95 o
@l 96 u    @l 97 u    @l 98 ye   @l 99 Oe   @l 9a Ue   @l 9b o
@q 9c @>   @l 9d O    @q 9e @>   @q 9f @>
@l a0 a    @l a1 i    @l a2 o    @l a3 u    @l a4 n    @l a5 N
@q a6 @>   @q a7 @>   @q a8 @>   @q a9 @>   @q aa @>   @q ab @>
@q ac @>   @q ad @>   @q ae @>   @q af @>
@q b0 @>   @q b1 @>   @q b2 @>   @q b3 @>   @q b4 @>   @l b5 A
@l b6 A    @l b7 A    @q b8 @>   @q b9 @>   @q ba @>   @q bb @>
@q bc @>   @q bd @>   @q be @>   @q bf @>
@q c0 @>   @q c1 @>   @q c2 @>   @q c3 @>   @q c4 @>   @q c5 @>
@l c6 a    @l c7 A    @q c8 @>   @q c9 @>   @q ca @>   @q cb @>
@q cc @>   @q cd @>   @q ce @>   @q cf @>
@q d0 @>   @q d1 @>   @l d2 E    @l d3 Ee   @l d4 E    @q d5 @>
@l d6 I    @l d7 I    @l d8 Ie   @q d9 @>   @q da @>   @q db @>
@q dc @>   @q dd @>   @l de I    @q df @>
@l e0 O    @l e1 ss   @l e2 O    @l e3 O    @l e4 o    @l e5 O
@l e6 mu   @q e7 @>   @q e8 @>   @l e9 U    @l ea U    @l eb U
@l ec y    @l ed Y    @q ee @>   @q ef @>
