.TH OVP2OVF 1 "8 March 2022" "Web2C @VERSION@"
.PP 
.SH "NAME" 
ovp2ovf \- convert a virtual property-list file into a virtual font file and its associated font metric file
.PP 
.SH "SYNOPSIS" 
.B ovp2ovf
.RI [ OPTIONS ]
.IR OVPFILE [ \fB.ovp\fP ]
.RI [ OVFFILE [ \fB.ovf\fP ]
.RI [ OFMFILE [ \fB.ofm\fP ]]]
.PP 
.SH "DESCRIPTION" 
.PP 
\fBovp2ovf\fP translates a human-readable virtual property list (OVP)
file, \fIOVPFILE\fP, into a virtual font (OVF) file, \fIOVFFILE\fP
and its companion font metric (OFM) file, \fIOFMFILE\fP\&.
.PP 
The program also works with TeX VP files, producing VF and TFM files\&.
(\fBovp2ovf\fP is based on the WEB source code for \fBvptovf\fP(1)\&.)
.PP 
.SH "OPTIONS" 
.PP 
.IP "\fB-help\fP" 
display a brief summary of syntax and options 
.IP "\fB-verbose\fP" 
display progress reports
.IP "\fB-version\fP" 
output version information and exit
.IP 
.PP 
.SH "FILES" 
.IP "\fIOFMFILE\fP" 
Omega Font Metric file
.IP "\fIOVFFILE\fP" 
Omega Virtual Font file
.IP "\fIOVPFILE\fP" 
Omega Virtual Property List file
.PP 
.SH "BUGS" 
.PP 
Email bug reports to <https://lists.tug.org/tex-k>
(mailing list); good to check if the same bug is present in
\fBvptovf\fP(1)\&.
.PP 
.SH "SEE ALSO" 
.PP 
\fBomega\fP(1), \fBofm2opl\fP(1), \fBovf2ovp\fP(1),
\fBpltotf\fP(1), \fBtftopl\fP(1), \fBvftovp\fP(1),
\fBvptovf\fP(1)
.PP 
.SH "AUTHOR" 
.PP 
According to the WEB documentation:
.PP 
.RS 
\fBVPtoVF\fP is an extended version of the program \fBPLtoTF\fP,
which is part of the standard TeXware library\&.  \fBOVP2OVF\fP is an
extended version of \fBVPtoVF\fP that allows much larger fonts\&.  The
idea of a virtual font was inspired by the work of David R\&. Fuchs who
designed a similar set of conventions in 1984 while developing a
device driver for ArborText, Inc\&.  He wrote a somewhat similar program
called \fBPLFONT\fP\&.
.RE 
.PP 
The primary authors of Omega were John Plaice and Yannis Haralambous.
Omega (and Aleph) are now maintained as part of TeX Live.
.PP 
This manual page was written by C\&.M\&. Connelly for the Debian
GNU/Linux system\&. It is also now maintained as part of TeX Live.
